/*
 *   This software is Copyright 1988 by Radical Eye Software.
 *   All Rights Reserved.
 */
/*
 *   download.c of dvisw software package.  Downloads a font to the
 *   smartwriter.  If passed a NULL pointer, it finishes up the last
 *   definition.
 */
#include "structures.h"
#ifdef SYSV
#include <string.h>
#else
#include <strings.h>
#endif
/*
 *   These are the external routines we call.
 */
extern int free() ;
extern void numout() ;
extern void mhexout() ;
extern void cmdout() ;
extern long unpack() ;
extern void flip() ;
extern void specialout() ;
extern long getlong() ;
extern void error() ;
extern char *nextstring ;
/*
 *   These are the external variables we access.
 */
extern fontdesctype *TeXfonts[] ;
extern FILE *bitfile ;
extern fontdesctype *curfnt ;
extern long bytesleft ;
extern quarterword *raster ;
extern Boolean compressed ;
extern integer mag ;
/*
 *   We might use malloc here.
 */
extern char *malloc() ;
/*
 *   We have a routine which downloads an individual character.
 */
void downchar(c, cc)
chardesctype *c ;
shalfword cc ;
{
   register long i, j ;
   register halfword cheight, cwidth ;
   register long k ;
   register quarterword *p ;
   register halfword cmd ;
   register shalfword xoff, yoff ;
   halfword wwidth ;
   register long len ;

   p = c->packptr ;
   cmd = *p++ ;
   if (cmd & 4) {
      if ((cmd & 7) == 7) {
         cwidth = getlong(p) ;
         cheight = getlong(p + 4) ;
         xoff = getlong(p + 8) ;
         yoff = getlong(p + 12) ;
         p += 16 ;
      } else {
         cwidth = p[0] * 256 + p[1] ;
         cheight = p[2] * 256 + p[3] ;
         xoff = p[4] * 256 + p[5] ;
         yoff = p[6] * 256 + p[7] ;
         p += 8 ;
      }
   } else {
      cwidth = *p++ ;
      cheight = *p++ ;
      xoff = *p++ ;
      yoff = *p++ ;
      if (xoff > 127)
         xoff -= 256 ;
      if (yoff > 127)
         yoff -= 256 ;
   }
   if (compressed) {
      len = getlong(p) ;
   } else {
      wwidth = (cwidth + 15) / 16 ;
      i = 2 * cheight * (long)wwidth ;
      if (i <= 0)
         i = 2 ;
      if (bytesleft < i) {
         if (bytesleft >= RASTERCHUNK)
            (void) free((char *) raster) ;
         if (RASTERCHUNK > i) {
            raster = (quarterword *)malloc(RASTERCHUNK) ;
            bytesleft = RASTERCHUNK ;
         } else {
            raster = (quarterword *)malloc((unsigned)i) ;
            bytesleft = i ;
         }
         if (raster == NULL) {
            error("! out of memory during allocation") ;
         }
      }
      k = i;
      while (k > 0)
         raster[--k] = 0 ;
      unpack(p, raster, cwidth, cheight, cmd) ;
      len = i ;
   }
   if (cheight == 0 || cwidth == 0 || len == 0) {
      cwidth = 1 ;
      cheight = 1 ;
      len = 1 ;
      raster[0] = 0 ;
   }
/*
 *   Now we actually send out the data.
 */
   specialout('[') ;
   specialout('<') ;
/*
 *   The funny thing is, we need to output the characters from the
 *   bottom up!  Ha ha ha he he ho ho ho ha ha . . . uh . . .
 */
   if (compressed) {
      p += 4 ;
      mhexout(p, len) ;
   } else {
      p = raster ;
      i = (cwidth + 7) / 8 ;
      for (j=0; j<cheight; j++) {
         mhexout(p, i) ;
         p += i ;
         if (((cwidth - 1) & 8) == 0)
            p++ ;
      }
   }
   specialout('>') ;
   numout((integer)cwidth) ;
   numout((integer)cheight) ;
   numout((integer)xoff) ;
   numout((integer)(cheight - yoff - 1)) ;
   numout((integer)(c->pixelwidth)) ;
   specialout(']') ;
   numout((integer)cc) ;
   cmdout("dc") ;
}
/*
 *   And the download procedure.
 */
void download(p, psfont)
charusetype *p ;
int psfont ;
{
   register halfword b, bit ;
   register chardesctype *c ;
   int cc ;
   char name[10] ;

   if (psfont < 27)
      (void)sprintf(name, "/f%c", 'a'+psfont-1) ;
   else
      (void)sprintf(name, "/f%d", psfont-27) ;
   cmdout(name) ;
   curfnt = TeXfonts[p->fontnum] ;
   curfnt->psname = psfont ;
   if (curfnt->resfont) {
      (void)strcpy(nextstring, "/") ;
      (void)strcat(nextstring, curfnt->resfont->PSname) ;
      if (curfnt->resfont->specialinstructions &&
          curfnt->resfont->sent == 0) {
            cmdout(nextstring) ;
            cmdout(curfnt->resfont->specialinstructions) ;
            curfnt->resfont->sent = 1 ;
      }
      cmdout("[") ;
      c = curfnt->chardesc ;
      for (cc=0; cc<256; cc++, c++)
         numout((integer)c->pixelwidth) ;
      cmdout("]") ;
      cmdout(nextstring) ;
      (void)sprintf(nextstring, "%ld", mag) ;
      cmdout(nextstring) ;
      (void)sprintf(nextstring, "%ld", curfnt->designsize) ;
      cmdout(nextstring) ;
      (void)sprintf(nextstring, "%ld", curfnt->scaledsize) ;
      cmdout(nextstring) ;
      cmdout("pf") ;
      return ;
   }
   cmdout("df") ;
   c = curfnt->chardesc ;
   cc = 0 ;
   for (b=0; b<16; b++) {
      for (bit=32768; bit>0; bit>>=1) {
         if (p->bitmap[b] & bit) {
            downchar(c, cc) ;
            c->flags |= EXISTS ;
         } else
            c->flags &= ~EXISTS ;
         c++ ;
         cc++ ;
      }
   }
   cmdout("dfe") ;
}
