/*
 *   Compressed TeX fonts in PostScript.  Copyright (C) 1989
 *   by Radical Eye Software.  All Rights Reserved.
 */
#include "structures.h"
/*
 *   Our input bytes are packed to the 16-bit word.  On output,
 *   we only need to byte-align the data.
 */
#define DIFFERENT (1)
#define LSHPOSSIB (2)
#define RSHPOSSIB (4)
#define BLKPOSSIB (8)
#define WHTPOSSIB (16)
#define ENDROW (32)
#define ABBRV0(n) ((n&(LSHPOSSIB|RSHPOSSIB|BLKPOSSIB|WHTPOSSIB))!=0)
#define ABBRVX(n) ((n&(LSHPOSSIB|RSHPOSSIB))!=0)
#define MAXOUT (17)
#define CMD(n) ((MAXOUT+1)*(n))
#define ADVXCHG1 CMD(0)
#define ADVXCHG1END CMD(1)
#define CHGX CMD(2)
#define CHGXEND CMD(3)
#define ADVXLSH CMD(4)
#define ADVXLSHEND CMD(5)
#define ADVXRSH CMD(6)
#define ADVXRSHEND CMD(7)
#define ADVX CMD(8)
#define REPX CMD(9)
#define SETX CMD(10)
#define CLRX CMD(11)
#define ADVXCHG2 CMD(12)
#define ADVXCHG2END CMD(13)
#define END CMD(14)
extern char *malloc() ;
extern free() ;
extern void error() ;
extern long getlong() ;
extern long unpack() ;
static int rowlength = 0 ;
static unsigned char *specdata ;
static long tslen = 0 ;
static unsigned char *tempstore, *tsp, *tsend ;
#define addtse(n) {lcm=tsp-tempstore;addts(n);}
static long addts(what)
register unsigned char what ;
{
   register unsigned char *p, *q ;

   if (tsp >= tsend) {
      if (tempstore == NULL) {
         tslen = 4096 ;
         tempstore = (unsigned char *)malloc((unsigned)tslen) ;
         if (tempstore == NULL)
            error("! out of memory") ;
         tsp = tempstore ;
      } else {
         tslen = 2 * tslen ;
         tsp = (unsigned char *)malloc((unsigned)tslen) ;
         if (tsp == NULL)
            error("! out of memory") ;
         for (p=tempstore, q=tsp; p<tsend; p++, q++)
            *q = *p ;
         free((char *)tempstore) ;
         tempstore = tsp ;
         tsp = q ;
      }
      tsend = tempstore + tslen ;
   }
   *tsp++ = what ;
}
static inittsp() {
   tsp = tempstore ;
   tsend = tempstore + tslen ;
}
#define rsh(a,b) ( ((a)==0) ? ((b)==128) : ( ((a)==255) ? ((b)==127) :\
                                    ((b)==(((a)>>1)|((a)&128))) ))
#define lsh(a,b) ( ((a)==0) ? ((b)==1) : ( ((a)==255) ? ((b)==254) :\
                                    ((b)==((((a)<<1)&255)|((a)&1))) ))
void dochar(from, width, height)
unsigned char *from ;
short width, height ; /* in bytes */
{
   register int i ;
   register unsigned char *f, *t, *d ;
   register unsigned char *e ;
   register int accum ;
   int j, k ;
   int diffrow ;
   int repeatcount ;
   int lit, pos, cmd ;
   long lcm ;
   int widthc ;

   widthc = width ;
   lcm = -1 ;
   if (width & 1)
      widthc ++ ;
   if (width > rowlength) {
      if (rowlength)
         free((char *)specdata) ;
      rowlength = 2 * widthc ;
      specdata = (unsigned char *)malloc((unsigned)(rowlength + 1)) ;
      if (specdata == NULL)
         error("! out of memory") ;
   }
   for (i=0, t=specdata; i<widthc; i++, t++)
      *t = 0 ;
   f = specdata ;
   repeatcount = 0 ;
   for (j=0; j<height; j++, f = from, from += widthc) {
      diffrow = 0 ;
      for (i=0, t=from, d=specdata; i<width; i++, f++, t++, d++) {
         if (*f == *t) {
            if (*t == 0)
               *d = WHTPOSSIB ;
            else if (*t == 255)
               *d = BLKPOSSIB ;
            else
               *d = 0 ;
         } else {
            accum = DIFFERENT ;
            if (rsh(*f, *t))
               accum |= RSHPOSSIB ;
            else if (lsh(*f, *t))
               accum |= LSHPOSSIB ;
            if (*t == 0)
               accum |= WHTPOSSIB ;
            else if (*t == 255)
               accum |= BLKPOSSIB ;
            *d = accum ;
            diffrow++ ;
         }
      }
      *d = ENDROW ;
      if (diffrow == 0) {
         repeatcount++ ;
      } else {
         if (repeatcount) {
            while (repeatcount > MAXOUT) {
               addts((unsigned char)(REPX+MAXOUT)) ;
               repeatcount -= MAXOUT ;
            }
            addts((unsigned char)(REPX+repeatcount)) ;
            repeatcount = 0 ;
         }
         pos = 0 ;
         for (i=0, d=specdata, f=t-width; i<width;) {
            if ((*d & DIFFERENT) == 0) {
               i++ ;
               d++ ;
               f++ ;
            } else {
               accum = 0 ;
               if (pos != i)
                  lit = ! ABBRVX(*d) ;
               else
                  lit = ! ABBRV0(*d) ;
               for (e=d; ;e++) {
                  if (! ABBRV0(*e))
                     lit = 1 ;
                  if ((*e & DIFFERENT) == 0)
                     break ;
                  if ((*e & WHTPOSSIB) &&
                      (e[1] & WHTPOSSIB)) {
                     while (*e & WHTPOSSIB) {
                        e++ ;
                        accum++ ;
                     }
                     cmd = CLRX ;
                     e -= accum ;
                     break ;
                  } else if ((*e & BLKPOSSIB) &&
                      (e[1] & BLKPOSSIB)) {
                     while (*e & BLKPOSSIB) {
                        e++ ;
                        accum++ ;
                     }
                     cmd = SETX ;
                     e -= accum ;
                     break ;
                  }
               }
               while (i - pos > MAXOUT) {
                  addts((unsigned char)(ADVX+MAXOUT)) ;
                  pos += MAXOUT ;
               }
               if (k = (e - d)) {
                  if (i > pos && ! ABBRVX(*d) && k > 2) {
                     addts((unsigned char)(ADVX + i - pos)) ;
                     pos = i ;
                  }
                  if (lit) {
                     if (k > 2) {
                        if (i > pos) {
                           addts((unsigned char)(ADVX + i - pos)) ;
                           pos = i ;
                        }
                        while (k > MAXOUT) {
                           addts((unsigned char)(CHGX + MAXOUT)) ;
                           for (k=0; k<MAXOUT; k++)
                              addts((unsigned char)(*f++)) ;
                           d += MAXOUT ;
                           pos += MAXOUT ;
                           i += MAXOUT ;
                           k -= MAXOUT ;
                        }
                        addtse((unsigned char)(CHGX + k)) ;
                        pos += k ;
                        for (; d<e; d++, i++, f++)
                           addts((unsigned char)(*f)) ;
                     } else {
                        if (k == 1) {
                           addtse((unsigned char)(ADVXCHG1 + i - pos)) ;
                           addts((unsigned char)(*f)) ;
                           i++ ;
                           pos = i ;
                           d++ ;
                           f++ ;
                        } else {
                           addtse((unsigned char)(ADVXCHG2 + i - pos)) ;
                           addts((unsigned char)(*f)) ;
                           addts((unsigned char)(f[1])) ;
                           i += 2 ;
                           pos = i ;
                           d += 2 ;
                           f += 2 ;
                        }
                     }
                  } else {
                     while (e > d) {
                        if (*d & LSHPOSSIB) {
                           addtse((unsigned char)(ADVXLSH + i - pos)) ;
                        } else if (*d & RSHPOSSIB) {
                           addtse((unsigned char)(ADVXRSH + i - pos)) ;
                        } else if (*d & WHTPOSSIB) {
                           addts((unsigned char)(CLRX + 1)) ; lcm = -1 ;
                        } else if (*d & BLKPOSSIB) {
                           addts((unsigned char)(SETX + 1)) ; lcm = -1 ;
                        } else
                           error("! should have been abbrev") ;
                        d++ ;
                        f++ ;
                        i++ ;
                        pos = i ;
                     }
                  }
               }
               if (accum > 0) {
                  if (i > pos) {
                     addts((unsigned char)(ADVX + i - pos)) ;
                     pos = i ;
                  }
                  i += accum ;
                  d += accum ;
                  f += accum ;
                  while (accum > MAXOUT) {
                     addts((unsigned char)(cmd + MAXOUT)) ;
                     accum -= MAXOUT ;
                     pos += MAXOUT ;
                  }
                  lcm = -1 ;
                  addts((unsigned char)(cmd + accum)) ;
                  pos += accum ;
               }
            }
         }
         if (lcm != -1) {
            tempstore[lcm] += MAXOUT + 1 ;
            lcm = -1 ;
         } else {
            addts((unsigned char)(END)) ;
         }
      }
   }
   if (repeatcount) {
      while (repeatcount > MAXOUT) {
         addts((unsigned char)(REPX+MAXOUT)) ;
         repeatcount -= MAXOUT ;
      }
      addts((unsigned char)(REPX+repeatcount)) ;
      repeatcount = 0 ;
   }
}

extern long bytesleft ;
extern quarterword *raster ;
static long mbytesleft ;
static quarterword *mraster ;

char *
makecopy(what, len, p)
register unsigned char *what ;
register long len ;
register unsigned char *p ;
{
   register unsigned char *q ;

   if (p == NULL) {
      if (len > 32760)
         error("! oops, raster too big") ;
      if (bytesleft < len) {
         if (RASTERCHUNK > len) {
            raster = (quarterword *)malloc((unsigned)RASTERCHUNK) ;
            bytesleft = RASTERCHUNK ;
         } else {
            raster = (quarterword *)malloc((unsigned)(len + 3)) ;
            bytesleft = len ;
         }
         if (raster == NULL) {
            error("! out of memory during allocation") ;
         }
      }
      p = (unsigned char *)raster ;
      bytesleft -= len ;
      raster += len ;
   }
   q = p ;
   while (len > 0) {
      *p++ = *what++ ;
      len -- ;
   }
   return ((char *)q) ;
}
repack(cp)
register chardesctype *cp ;
{
   register long i, j ;
   register unsigned char *p ;
   register int width, height ;
   register int wwidth ;

   p = cp->packptr ;
   if (p == NULL)
      error("! no raster?") ;
   inittsp() ;
   addts(*p) ;
   if (*p & 4) {
      if ((*p & 7) == 7) {
         width = getlong(p + 1) ;
         height = getlong(p + 5) ;
         for (i=0; i<12; i++)
            addts(*++p) ;
      } else {
         width = p[1] * 256 + p[2] ;
         height = p[3] * 256 + p[4] ;
         addts(*++p) ;
         addts(*++p) ;
         addts(*++p) ;
         addts(*++p) ;
      }
   } else {
      width = p[1] ;
      height = p[2] ;
   }
   addts(*++p) ;
   addts(*++p) ;
   addts(*++p) ;
   addts(*++p) ;
   p++ ;
   for (i=0; i<4; i++)
      addts((unsigned char)0) ;
   wwidth = (width + 15) / 16 ;
   i = 2 * height * (long)wwidth ;
   if (i <= 0)
      i = 2 ;
   if (mbytesleft < i) {
      if (mbytesleft >= RASTERCHUNK)
         (void) free((char *) mraster) ;
      if (RASTERCHUNK > i) {
         mraster = (quarterword *)malloc((unsigned)RASTERCHUNK) ;
         mbytesleft = RASTERCHUNK ;
      } else {
         mraster = (quarterword *)malloc((unsigned)(i + 3)) ;
         mbytesleft = i ;
      }
      if (mraster == NULL) {
         error("! out of memory during allocation") ;
      }
   }
   j = i;
   while (j > 0)
      mraster[--j] = 0 ;
   i = p - cp->packptr ;
   i += unpack(p, mraster, width, height, *(cp->packptr)) ;
   dochar(mraster, (width + 7) >> 3, height) ;
   j = tsp - tempstore ;
   if ( i < j )
      cp->packptr = (unsigned char *)makecopy(tempstore, j, NULL) ;
   else
      makecopy(tempstore, j, cp->packptr) ;
   if (*(cp->packptr) & 4)
      if ((*(cp->packptr) & 7) == 7)
         putlong(cp->packptr + 17, j - 21) ;
      else
         putlong(cp->packptr + 9, j - 13) ;
   else
      putlong(cp->packptr + 5, j - 9) ;
   cp->flags |= REPACKED ;
}
putlong(a, i)
register char *a ;
long i ;
{
   register char *b = (char *)&i ;

   a[0] = b[0] ;
   a[1] = b[1] ;
   a[2] = b[2] ;
   a[3] = b[3] ;
}
long getlong(a)
register char *a ;
{
   long t ;
   register char *b ;

   b = (char *)&t ;
   b[0] = a[0] ;
   b[1] = a[1] ;
   b[2] = a[2] ;
   b[3] = a[3] ;
   return(t) ;
}
